import java.io.*;
import java.util.*;

import static java.lang.Math.max;
import static java.lang.Math.min;

public class crossy_ag_wa_swap_ud extends PrintWriter {
    final Random rand = new Random(31);
    final int inf = (int) 2e9;
    final long linf = (long) 1e18;

    final static String IO = "_std";

    int[] nx = new int[] {1, 2, 3, 0};
    int[][] ts = new int[4][];
    int[][] id = new int[4][];
    int[] p = new int[4];
    int[] ans;

    void solve() throws IOException {
        int n = nextInt();
        for (int i = 0; i < 4; i++) {
            ts[i] = new int[n + 1];
            id[i] = new int[n + 1];
        }

        int[] toDir = new int[256];
        toDir['D'] = 0;
        toDir['L'] = 1;
        toDir['U'] = 2;
        toDir['R'] = 3;

        for (int i = 0; i < n; i++) {
            int t = nextInt();
            int d = toDir[next().charAt(0)];
            ts[d][p[d]] = t;
            id[d][p[d]] = i;
            p[d]++;
        }

        for (int i = 0; i < 4; i++) {
            ts[i][p[i]] = inf;
            p[i] = 0;
        }

        ans = new int[n];
        Arrays.fill(ans, -1);
        int left = 0;
        boolean[] leaving = new boolean[4];

        while (left < n) {
            int mn = inf;
            for (int i = 0; i < 4; i++) {
                mn = min(mn, ts[i][p[i]]);
                leaving[i] = false;
            }

            boolean oneLeft = false;
            for (int i = 0; i < 4; i++) {
                if (ts[i][p[i]] == mn && ts[nx[i]][p[nx[i]]] != mn) {
                    leaving[i] = true;
                    oneLeft = true;
                }
            }

            if (!oneLeft) {
                break;
            }

            for (int i = 0; i < 4; i++) {
                if (leaving[i]) {
                    ans[id[i][p[i]]] = mn;
                    ts[i][p[i] + 1] = max(ts[i][p[i] + 1], mn + 1);
                    p[i]++;
                    left++;
                } else if (ts[i][p[i]] == mn){
                    ts[i][p[i]]++;
                }
            }
        }

        for (int i : ans) {
            println(i);
        }
    }

    BufferedReader in;
    StringTokenizer stok;

    crossy_ag_wa_swap_ud() {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    crossy_ag_wa_swap_ud(String fileIn, String fileOut) throws IOException {
        super(fileOut);
        in = new BufferedReader(new FileReader(fileIn));
    }

    public static void main(String[] args) throws IOException {
        crossy_ag_wa_swap_ud main;
        if ("_std".equals(IO)) {
            main = new crossy_ag_wa_swap_ud();
        } else if ("_iotxt".equals(IO)) {
            main = new crossy_ag_wa_swap_ud("input.txt", "output.txt");
        } else {
            main = new crossy_ag_wa_swap_ud(IO + ".in", IO + ".out");
        }
        main.solve();
        main.close();
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    int[] nextIntArray(int len) throws IOException {
        int[] a = new int[len];
        for (int i = 0; i < len; i++) {
            a[i] = nextInt();
        }
        return a;
    }

    int[] nextIntArraySorted(int len) throws IOException {
        int[] a = nextIntArray(len);
        shuffle(a);
        Arrays.sort(a);
        return a;
    }

    void shuffle(int[] a) {
        for (int i = 1; i < a.length; i++) {
            int x = rand.nextInt(i + 1);
            int _ = a[i];
            a[i] = a[x];
            a[x] = _;
        }
    }

    void shuffleAndSort(int[] a) {
        shuffle(a);
        Arrays.sort(a);
    }

    boolean nextPermutation(int[] p) {
        for (int a = p.length - 2; a >= 0; --a) {
            if (p[a] < p[a + 1])
                for (int b = p.length - 1; ; --b)
                    if (p[b] > p[a]) {
                        int t = p[a];
                        p[a] = p[b];
                        p[b] = t;
                        for (++a, b = p.length - 1; a < b; ++a, --b) {
                            t = p[a];
                            p[a] = p[b];
                            p[b] = t;
                        }
                        return true;
                    }
        }
        return false;
    }

    <T> List<T>[] createAdjacencyList(int n) {
        List<T>[] res = new List[n];
        for (int i = 0; i < n; i++) {
            res[i] = new ArrayList<>();
        }
        return res;
    }

    void println(Object... a) {
        for (int i = 0; i < a.length; i++) {
            if (i != 0) {
                print(" ");
            }
            print(a[i]);
        }
        println();
    }
}