#include "testlib.h"
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 100 * 1000;
const int MAXM = 100 * 1000;

vector<int> *graph;
vector<bool> vis;
vector<int> topsort;
void dfs(int u) {
    vis[u] = true;
    for (int v : graph[u])
        if (!vis[v])
            dfs(v);
    topsort.push_back(u);
}

int main() {
    registerValidation();

    int n = inf.readInt(2, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXM, "m");
    inf.readEoln();

    graph = new vector<int>[n];
    set<pair<int, int> > s;
    for (int i = 0; i < m; i++) {
        int x = inf.readInt(1, n, format("x[%d]", i));
        inf.readSpace();
        int y = inf.readInt(1, n, format("y[%d]", i));
        inf.readEoln();
        ensuref(x != y, "x[%d] should not be equal to y[%d]", i, i);
        graph[x - 1].push_back(y - 1);
        s.insert(make_pair(x, y));
    }

    inf.readEof();

    ensuref(s.size() == m, "each pair should appear in the test only once");

    vis.resize(n, false);
    for (int i = 0; i < n; i++)
        if (!vis[i])
            dfs(i);
    reverse(topsort.begin(), topsort.end());

    vector<int> reverse_transposition(n);
    for (int i = 0; i < n; i++)
        reverse_transposition[topsort[i]] = i;

    for (int u = 0; u < n; u++) {
        for (int v : graph[u])
            ensuref(reverse_transposition[u] < reverse_transposition[v], "there is a cycle");
    }
    
    return 0;
}
